config/routes.rb
Rails.application.routes.draw do
  root  'home#index'
  get 'home/index'
  get "/home/:state/cities"=> "home#cities"
  devise_for :users
  resources :profile, :controller => 'users'
  namespace :admin_role do
	  resources :users
	end
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/views/shared/_top_bar.html.erb
<nav class="navbar navbar-expand-md navbar-dark bg-dark mb-4">
  <a class="navbar-brand" href="#">Solbeg</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarCollapse">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="<% admin_role_users_path %>">Home <span class="sr-only">(current)</span></a>
      </li>
    </ul>
    <% if user_signed_in? %>
      <%= link_to "Sign Out", destroy_user_session_path, method: :delete, :class => "btn btn-secondary" %>
    <% else %>
      <%= link_to "Sign In", new_user_session_path, :class => "btn btn-primary" %>
      <%= link_to "Sign Up", new_user_registration_path, :class => "btn btn-warning" %>
    <% end %>
  </div>
</nav>

app/views/shared/_user_form.html.erb
<% if @user.errors.present? %>
  <div class="col-12-xxxl col-lg-12 col-12 form-group">
    <div id="error_explanation">
      <h4><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h4>
      <div class="row">
        <div class="col-lg-12 validation-err">
          <% @user.errors.messages.each_with_index do |error_message, index| %>
            <%= index + 1 %>) <%= error_message.first.to_s.split('_').join(' ').titleize %> : <%= error_message[1].last %> <br />
          <% end %>    
        </div>
      </div>
    </div>
  </div>
<% end %>

<% if current_user.admin? %>
  <% action_path = admin_role_user_path(@user) %>
  <% cancel_path = admin_role_users_path() %>
<% else %>
  <% action_path = profile_path(@user)  %>
  <% cancel_path = root_path  %>
  <% end %>
<%= form_for @user, url: action_path, action: 'PUT', :class => "form-horizontal"  do |f| %>
  <div class="form-group">
    <label class="control-label col-sm-2" for="email">Email:</label>
    <div class="col-sm-10">
    <% unless @flag %>
      <%= f.text_field :email, :placeholder=>"Email", :class=>"form-control form-control-line" %>
    <% else%>
      <%= f.text_field :email, :placeholder=>"Email", :class=>"form-control form-control-line", disabled: true %>
    <% end %>
    </div>
  </div>
  <div class="form-group">
    <label class="control-label col-sm-2" for="email">Name:</label>
    <div class="col-sm-10">
    <% unless @flag %>
      <%= f.text_field :name, :placeholder=>"Name", :class=>"form-control form-control-line" %>
    <% else %>
      <%= f.text_field :name, :placeholder=>"Name", :class=>"form-control form-control-line" , disabled: true%>
    <% end %>
    </div>
  </div>
  <% @user.build_address unless @user.address %>
  <%= f.fields_for :address do |ff| %>
    <div class="form-group">
      <label class="control-label col-sm-2" for="pwd">Street:</label>
      <div class="col-sm-10"> 
        <% unless @flag %>
          <%= ff.text_field :street, :placeholder=>"Street", :class=>"form-control form-control-line" %>
        <% else %>
          <%= ff.text_field :street, :placeholder=>"Street", :class=>"form-control form-control-line" , disabled: true%>
        <% end %>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="pwd">City:</label>
      <div class="col-sm-10"> 
      <% unless @flag %>
          <%= ff.text_field :city, :placeholder=>"City", :class=>"form-control form-control-line" %>
        <% else %>
          <%= ff.text_field :city, :placeholder=>"City", :class=>"form-control form-control-line" , disabled: true%>
        <% end %>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="pwd">State:</label>
      <div class="col-sm-10"> 
      <% unless @flag %>
          <%= ff.text_field :state, :placeholder=>"State", :class=>"form-control form-control-line" %>
        <% else %>
          <%= ff.text_field :state, :placeholder=>"State", :class=>"form-control form-control-line" , disabled: true%>
        <% end %>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="pwd">Landmark:</label>
      <div class="col-sm-10"> 
      <% unless @flag %>
          <%= ff.text_field :landmark, :placeholder=>"Landmark", :class=>"form-control form-control-line" %>
        <% else %>
          <%= ff.text_field :landmark, :placeholder=>"Landmark", :class=>"form-control form-control-line" , disabled: true%>
        <% end %>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="pwd">Pincode:</label>
      <div class="col-sm-10"> 
      <% unless @flag %>
          <%= ff.text_field :pincode, :placeholder=>"Pincode", :class=>"form-control form-control-line" %>
        <% else %>
          <%= ff.text_field :pincode, :placeholder=>"Pincode", :class=>"form-control form-control-line" , disabled: true%>
        <% end %>
      </div>
    </div>    
    <div class="form-group">
      <label class="control-label col-sm-2" for="pwd">Phone No:</label>
      <div class="col-sm-10"> 
        <%= ff.text_field :phone_no, :placeholder=>"Phone No", :class=>"form-control form-control-line" %>
      </div>
    </div>    
  <% end %>
  <div class="form-group">
    <label class="control-label col-sm-2" for="pwd">Pincode:</label>
    <div class="col-sm-10"> 
      <% unless @flag %>
        <%= f.file_field :profile_picture, :placeholder=>"Profile Picture", :class=>"form-control form-control-line" %>
        <% else %>
          <%= f.file_field :profile_picture, :placeholder=>"Profile Picture", :class=>"form-control form-control-line, disabled: true" , disabled: true%>
        <% end %>
    </div>
  </div>
  <div class="form-group"> 
    <div class="col-sm-offset-2 col-sm-10">
      <%= link_to "Cancel", cancel_path, :class => 'btn btn-secondary' %>
      <button type="submit" class="btn btn-primary">Submit</button>
    </div>
  </div>
<% end %>

app/views/shared/_user_profile.html.erb
<div class="container emp-profile">
            <form method="post">
                <div class="row">
                    <div class="col-md-4">
                        <div class="profile-img">
                            <%= image_tag "#{@user.profile_picture.url}", :class => 'width-100px' %>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="profile-head">
                                    <h4>
                                        <%= @user.name.titleize %>
                                    </h4>
                                    
                                    <h6>
                                        <%= @address.full_address %>
                                    </h6>

                                    <h6>
                                        <%= @address.pincode %>
                                    </h6>
                            <ul class="nav nav-tabs margin-top-20px" id="myTab" role="tablist">
                                <li class="nav-item">
                                    <a class="nav-link active" id="home-tab" data-toggle="tab" href="#home" role="tab" aria-controls="home" aria-selected="true">My Profile</a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <div class="col-md-2">
                      <%= link_to 'Edit Profile', edit_profile_path(@user) ,:class => "btn btn-primary btn-sm edit_profile" %>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-4">
                        <div class="profile-work">
                            
                        </div>
                    </div>
                    <div class="col-md-8">
                        <div class="tab-content profile-tab" id="myTabContent">
                            <div class="tab-pane fade show active" id="home" role="tabpanel" aria-labelledby="home-tab">
                                        <div class="row">
                                            <div class="col-md-6">
                                                <label>Name</label>
                                            </div>
                                            <div class="col-md-6">
                                                <p class="display-details"><%= @user.name %></p>
                                                <%#= f.text_field : , :class => "edit-details" %>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <label>Street</label>
                                            </div>
                                            <div class="col-md-6">
                                                <p class="display-details"><%= @address.street %></p>
                                                <%#= f.text_field : , :class => "edit-details" %>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <label>Address Line</label>
                                            </div>
                                            <div class="col-md-6">
                                                <%= @address.address_line %>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <label>City</label>
                                            </div>
                                            <div class="col-md-6">
                                                <p class="display-details"><%= @address.city %></p>
                                                <%#= f.text_field : , :class => "edit-details" %>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <label>State</label>
                                            </div>
                                            <div class="col-md-6">
                                                <p class="display-details"><%= @address.state %></p>
                                                <%#= f.text_field : , :class => "edit-details" %>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <label>Landmark</label>
                                            </div>
                                            <div class="col-md-6">
                                                <p class="display-details"><%= @address.landmark %></p>
                                                <%#= f.text_field : , :class => "edit-details" %>
                                            </div>
                                        </div>                                        
                            </div>
                        </div>
                    </div>
                </div>
            </form>           
        </div>